package com.ekexiu.portal.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Column;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.LimitSelect;
import org.jfw.apt.orm.annotation.dao.method.operator.QueryVal;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.param.LessThan;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.apt.orm.core.defaultImpl.IntHandler;

import com.ekexiu.portal.po.GrowthLog;
import com.ekexiu.portal.pojo.InviteUserScore;

@DAO
public abstract class GrowthLogDao {
	@Insert
	public abstract int insert(Connection con,GrowthLog growthLog)throws SQLException;
	
	@SelectList
	public abstract List<GrowthLog> queryOperate(Connection con,String professorId,String operate)throws SQLException;
	
	@SelectOne
	@Nullable
	public abstract GrowthLog querySignIn(Connection con,String professorId,String operate,@Like String createTime)throws SQLException;
	
	
	@LimitSelect
	@OrderBy("ORDER BY CREATE_TIME DESC")
	@Where("OPERATE='5'")
	public abstract List<GrowthLog> queryLastSignIn(Connection con,String professorId,int rows)throws SQLException;
	
	@LimitSelect
	@OrderBy("ORDER BY CREATE_TIME DESC")
	@Where("INVITE_PRO IS NULL")
	public abstract List<GrowthLog> queryList(Connection con,String professorId,@LessThan String createTime,int rows)throws SQLException;
	
	public List<InviteUserScore> queryInvite(Connection con,String professorId,int rows,int offset) throws SQLException{
        int index = 1;
        String sql = "SELECT INVITE_PRO,SUM(SCORE) S FROM GROWTH_LOG WHERE PROFESSOR_ID = ? AND INVITE_PRO IS NOT NULL GROUP BY INVITE_PRO ORDER BY S DESC LIMIT "+ rows + " OFFSET " + offset;
        PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(index++,professorId);
            ResultSet rs = ps.executeQuery();
            try{
                List<InviteUserScore> inviteUserScores = new ArrayList<InviteUserScore>();
                while(rs.next()){
                    InviteUserScore inviteUserScore =  new InviteUserScore();
                    inviteUserScore.setInviteUser(rs.getString(1));
                    inviteUserScore.setScore(rs.getInt(2));
                    inviteUserScores.add(inviteUserScore);
                }
                return inviteUserScores;
            }finally{
                try{rs.close();}catch(Exception e1){}
            }
        }finally{
            try{ps.close();}catch(Exception e2){}
        }
    }
	
	@DefaultValue("0")
	@QueryVal
	@Column(handlerClass=IntHandler.class,value="SUM(SCORE)")
	@Where("INVITE_PRO IS NOT NULL")
	@From(GrowthLog.class)
	public abstract int queryInviteScore(Connection con,String professorId) throws SQLException;
	@DefaultValue("0")
	@QueryVal
	@Column(handlerClass=IntHandler.class,value="SUM(SCORE)")
	@Where("INVITE_PRO IS NULL")
	@From(GrowthLog.class)
	public abstract int queryMyScore(Connection con,String professorId)throws SQLException;
	

	
//	@SelectList
//	@Where("(OPERATE = '2' OR OPERATE = '3' OR OPERATE = '4' OR OPERATE = '25' OR OPERATE = '26' OR OPERATE = '27' )")
//	public abstract List<GrowthLog> queryShare(Connection con,String professorId,@Like String createTime)throws SQLException;
	
	@QueryVal
	@Column(handlerClass=IntHandler.class,value="COUNT(1)")
	@From(GrowthLog.class)
	@DefaultValue("0")
	@Where("OPERATE ='4'")
	public abstract int queryCount4Agree(Connection con,String professorId,@Like String createTime)throws SQLException;
	@QueryVal
	@Column(handlerClass=IntHandler.class,value="COUNT(1)")
	@From(GrowthLog.class)
	@DefaultValue("0")
	@Where("OPERATE ='3'")
	public abstract int queryCount4LM(Connection con,String professorId,@Like String createTime)throws SQLException;	@QueryVal
	@Column(handlerClass=IntHandler.class,value="COUNT(1)")
	@From(GrowthLog.class)
	@DefaultValue("0")
	@Where("OPERATE ='2'")
	public abstract int queryCount4Share(Connection con,String professorId,@Like String createTime)throws SQLException;
	
}
