package com.ekexiu.portal.dao;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.orm.annotation.dao.Column;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.LimitSelect;
import org.jfw.apt.orm.annotation.dao.method.operator.QueryVal;
import org.jfw.apt.orm.annotation.dao.param.LessThan;
import org.jfw.apt.orm.core.defaultImpl.IntHandler;

import com.ekexiu.portal.po.LeaveWord;

@DAO
public abstract class LeaveWordDao {
	@Insert
	public abstract int insert(Connection con,LeaveWord word) throws SQLException;
	
	@QueryVal
	@From(LeaveWord.class)
	@Column(handlerClass=IntHandler.class,value={"COUNT(1)"})
	@DefaultValue("0")
	public abstract int queryCount(Connection con,String objId,String category)throws SQLException;

	@LimitSelect
	@OrderBy("ORDER BY CREATE_TIME DESC,ORDER_KEY DESC")
	public abstract List<LeaveWord> query(Connection con,String objId,String category,@LessThan String createTime,@LessThan long orderKey,int rows) throws SQLException; 
	
	@DeleteWith
	@From(LeaveWord.class)
	public abstract int deleteArticle(Connection con,String objId,String category)throws SQLException;
	
	@DeleteWith
	@From(LeaveWord.class)
	public abstract int delete(Connection con,String id)throws SQLException;
	
}
