package com.ekexiu.portal.editor;

import java.io.File;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.jfw.apt.annotation.Bean;
import org.jfw.util.ListUtil;
@Bean
public class EditorConfig {
    private File rootPath;
    
    /* 执行上传图片的action名称 */
    private String imageActionName = "uploadimage";
    /* 提交的图片表单名称 */
    private String imageFieldName = "upfile";
    /* 上传大小限制，单位B */
    private long imageMaxSize = 2048000;
    /* 上传图片格式显示 */
    private String imageAllowFiles = "png,jpg,jpeg,gif,bmp";
    /* 是否压缩图片,默认是true */
    private boolean imageCompressEnable = true;
    /* 图片压缩最长边限制 */
    private long imageCompressBorder = 1600;
    /* 插入的图片浮动方式 */
    private String imageInsertAlign = "none";
    /* 图片访问路径前缀 */
    private String imageUrlPrefix = "";
    /* 上传保存路径,可以自定义保存路径和文件名格式 */
    /* {filename} 会替换成原文件名,配置这项需要注意中文乱码问题 */
    /* {rand:6} 会替换成随机数,后面的数字是随机数的位数 */
    /* {time} 会替换成时间戳 */
    /* {yyyy} 会替换成四位年份 */
    /* {yy} 会替换成两位年份 */
    /* {mm} 会替换成两位月份 */
    /* {dd} 会替换成两位日期 */
    /* {hh} 会替换成两位小时 */
    /* {ii} 会替换成两位分钟 */
    /* {ss} 会替换成两位秒 */
    /* 非法字符 \ : * ? " < > | */
    /* 具请体看线上文档: fexbaiducom/ueditor/#use-format_upload_filename */

    private String imagePathFormat = "/data/editor/image/{yyyy}{mm}{dd}/{time}{rand:6}";
    /* 涂鸦图片上传配置项 */
    /* 执行上传涂鸦的action名称 */
    private String scrawlActionName = "uploadscrawl";
    /* 提交的图片表单名称 */
    private String scrawlFieldName = "upfile";
    /* 上传保存路径,可以自定义保存路径和文件名格式 */
    private String scrawlPathFormat = "/data/editor/image/{yyyy}{mm}{dd}/{time}{rand:6}";
    /* 上传大小限制，单位B */
    private long scrawlMaxSize = 2048000;
    private String scrawlUrlPrefix = "";
    /* 图片访问路径前缀 */
    private String scrawlInsertAlign = "none";

    /* 截图工具上传 */
    /* 执行上传截图的action名称 */
    private String snapscreenActionName = "uploadimage";
    /* 上传保存路径,可以自定义保存路径和文件名格式 */
    private String snapscreenPathFormat = "/data/editor/image/{yyyy}{mm}{dd}/{time}{rand:6}";
    /* 图片访问路径前缀 */
    private String snapscreenUrlPrefix = "";
    /* 插入的图片浮动方式 */
    private String snapscreenInsertAlign = "none";

    /* 抓取远程图片配置 */
    private String catcherLocalDomain = "127001,localhost,imgbaiducom";
    /* 执行抓取远程图片的action名称 */
    private String catcherActionName = "catchimage";
    /* 提交的图片列表表单名称 */
    private String catcherFieldName = "source";
    /* 上传保存路径,可以自定义保存路径和文件名格式 */
    private String catcherPathFormat = "/data/editor/image/{yyyy}{mm}{dd}/{time}{rand:6}";
    /* 图片访问路径前缀 */
    private String catcherUrlPrefix = "";
    /* 上传大小限制，单位B */
    private long catcherMaxSize = 2048000;
    /* 抓取图片格式显示 */
    private String catcherAllowFiles = "png,jpg,jpeg,gif,bmp";

    /* 上传视频配置 */
    /* 执行上传视频的action名称 */
    private String videoActionName = "uploadvideo";
    /* 提交的视频表单名称 */
    private String videoFieldName = "upfile";
    /* 上传保存路径,可以自定义保存路径和文件名格式 */
    private String videoPathFormat = "/data/editor/video/{yyyy}{mm}{dd}/{time}{rand:6}";
    /* 视频访问路径前缀 */
    private String videoUrlPrefix = "";
    /* 上传大小限制，单位B，默认100MB */
    private long videoMaxSize = 102400000;
    /* 上传视频格式显示 */
    private String videoAllowFiles = "flv,swf,mkv,avi,rm,rmvb,mpeg,mpg,ogg,ogv,mov,wmv,mp4,webm,mp3,wav,mid";

    /* 上传文件配置 */
    /* controller里,执行上传视频的action名称 */
    private String fileActionName = "uploadfile";
    /* 提交的文件表单名称 */
    private String fileFieldName = "upfile";
    /* 上传保存路径,可以自定义保存路径和文件名格式 */
    private String filePathFormat = "/data/editor/file/{yyyy}{mm}{dd}/{time}{rand:6}";
    /* 文件访问路径前缀 */
    private String fileUrlPrefix = "";
    /* 上传大小限制，单位B，默认50MB */
    private long fileMaxSize = 51200000;
    /* 上传文件格式显示 */
    private String fileAllowFiles = "png,jpg,jpeg,gif,bmp,flv,swf,mkv,avi,rm,rmvb,mpeg,mpg,ogg,ogv,mov,wmv,mp4,webm,mp3,wav,mid,rar,zip,tar,gz,7z,bz2,cab,iso,doc,docx,xls,xlsx,ppt,pptx,pdf,txt,md,xml";

    /* 列出指定目录下的图片 */
    /* 执行图片管理的action名称 */
    private String imageManagerActionName = "listimage";
    /* 指定要列出图片的目录 */
    private String imageManagerListPath = "/data/editor/image/";
    /* 每次列出文件数量 */
    private long imageManagerListSize = 20;
    /* 图片访问路径前缀 */
    private String imageManagerUrlPrefix = "";
    /* 插入的图片浮动方式 */
    private String imageManagerInsertAlign = "none";
    /* 列出的文件类型 */
    private String imageManagerAllowFiles = "png,jpg,jpeg,gif,bmp";

    /* 列出指定目录下的文件 */
    /* 执行文件管理的action名称 */
    private String fileManagerActionName = "listfile";
    /* 指定要列出文件的目录 */
    private String fileManagerListPath = "/data/editor/upload/file/";
    /* 文件访问路径前缀 */
    private String fileManagerUrlPrefix = "";
    /* 每次列出文件数量 */

    private long fileManagerListSize = 20;
    /* 列出的文件类型 */
    private String fileManagerAllowFiles = "png,jpg,jpeg,gif,bmp,flv,swf,mkv,avi,rm,rmvb,mpeg,mpg,ogg,ogv,mov,wmv,mp4,webm,mp3,wav,mid,rar,zip,tar,gz,7z,bz2,cab,iso,doc,docx,xls,xlsx,ppt,pptx,pdf,txt,md,xml";

    public String getImageActionName() {
        return imageActionName;
    }

    public void setImageActionName(String imageActionName) {
        this.imageActionName = imageActionName;
    }

    public String getImageFieldName() {
        return imageFieldName;
    }

    public void setImageFieldName(String imageFieldName) {
        this.imageFieldName = imageFieldName;
    }

    public long getImageMaxSize() {
        return imageMaxSize;
    }

    public void setImageMaxSize(long imageMaxSize) {
        this.imageMaxSize = imageMaxSize;
    }

    public String getImageAllowFiles() {
        return imageAllowFiles;
    }

    public void setImageAllowFiles(String imageAllowFiles) {
        this.imageAllowFiles = imageAllowFiles;
    }

    public boolean isImageCompressEnable() {
        return imageCompressEnable;
    }

    public void setImageCompressEnable(boolean imageCompressEnable) {
        this.imageCompressEnable = imageCompressEnable;
    }

    public long getImageCompressBorder() {
        return imageCompressBorder;
    }

    public void setImageCompressBorder(long imageCompressBorder) {
        this.imageCompressBorder = imageCompressBorder;
    }

    public String getImageInsertAlign() {
        return imageInsertAlign;
    }

    public void setImageInsertAlign(String imageInsertAlign) {
        this.imageInsertAlign = imageInsertAlign;
    }

    public String getImageUrlPrefix() {
        return imageUrlPrefix;
    }

    public void setImageUrlPrefix(String imageUrlPrefix) {
        this.imageUrlPrefix = imageUrlPrefix;
    }

    public String getImagePathFormat() {
        return imagePathFormat;
    }

    public void setImagePathFormat(String imagePathFormat) {
        this.imagePathFormat = imagePathFormat;
    }

    public String getScrawlActionName() {
        return scrawlActionName;
    }

    public void setScrawlActionName(String scrawlActionName) {
        this.scrawlActionName = scrawlActionName;
    }

    public String getScrawlFieldName() {
        return scrawlFieldName;
    }

    public void setScrawlFieldName(String scrawlFieldName) {
        this.scrawlFieldName = scrawlFieldName;
    }

    public String getScrawlPathFormat() {
        return scrawlPathFormat;
    }

    public void setScrawlPathFormat(String scrawlPathFormat) {
        this.scrawlPathFormat = scrawlPathFormat;
    }

    public long getScrawlMaxSize() {
        return scrawlMaxSize;
    }

    public void setScrawlMaxSize(long scrawlMaxSize) {
        this.scrawlMaxSize = scrawlMaxSize;
    }

    public String getScrawlUrlPrefix() {
        return scrawlUrlPrefix;
    }

    public void setScrawlUrlPrefix(String scrawlUrlPrefix) {
        this.scrawlUrlPrefix = scrawlUrlPrefix;
    }

    public String getScrawlInsertAlign() {
        return scrawlInsertAlign;
    }

    public void setScrawlInsertAlign(String scrawlInsertAlign) {
        this.scrawlInsertAlign = scrawlInsertAlign;
    }

    public String getSnapscreenActionName() {
        return snapscreenActionName;
    }

    public void setSnapscreenActionName(String snapscreenActionName) {
        this.snapscreenActionName = snapscreenActionName;
    }

    public String getSnapscreenPathFormat() {
        return snapscreenPathFormat;
    }

    public void setSnapscreenPathFormat(String snapscreenPathFormat) {
        this.snapscreenPathFormat = snapscreenPathFormat;
    }

    public String getSnapscreenUrlPrefix() {
        return snapscreenUrlPrefix;
    }

    public void setSnapscreenUrlPrefix(String snapscreenUrlPrefix) {
        this.snapscreenUrlPrefix = snapscreenUrlPrefix;
    }

    public String getSnapscreenInsertAlign() {
        return snapscreenInsertAlign;
    }

    public void setSnapscreenInsertAlign(String snapscreenInsertAlign) {
        this.snapscreenInsertAlign = snapscreenInsertAlign;
    }

    public String getCatcherLocalDomain() {
        return catcherLocalDomain;
    }

    public void setCatcherLocalDomain(String catcherLocalDomain) {
        this.catcherLocalDomain = catcherLocalDomain;
    }

    public String getCatcherActionName() {
        return catcherActionName;
    }

    public void setCatcherActionName(String catcherActionName) {
        this.catcherActionName = catcherActionName;
    }

    public String getCatcherFieldName() {
        return catcherFieldName;
    }

    public void setCatcherFieldName(String catcherFieldName) {
        this.catcherFieldName = catcherFieldName;
    }

    public String getCatcherPathFormat() {
        return catcherPathFormat;
    }

    public void setCatcherPathFormat(String catcherPathFormat) {
        this.catcherPathFormat = catcherPathFormat;
    }

    public String getCatcherUrlPrefix() {
        return catcherUrlPrefix;
    }

    public void setCatcherUrlPrefix(String catcherUrlPrefix) {
        this.catcherUrlPrefix = catcherUrlPrefix;
    }

    public long getCatcherMaxSize() {
        return catcherMaxSize;
    }

    public void setCatcherMaxSize(long catcherMaxSize) {
        this.catcherMaxSize = catcherMaxSize;
    }

    public String getCatcherAllowFiles() {
        return catcherAllowFiles;
    }

    public void setCatcherAllowFiles(String catcherAllowFiles) {
        this.catcherAllowFiles = catcherAllowFiles;
    }

    public String getVideoActionName() {
        return videoActionName;
    }

    public void setVideoActionName(String videoActionName) {
        this.videoActionName = videoActionName;
    }

    public String getVideoFieldName() {
        return videoFieldName;
    }

    public void setVideoFieldName(String videoFieldName) {
        this.videoFieldName = videoFieldName;
    }

    public String getVideoPathFormat() {
        return videoPathFormat;
    }

    public void setVideoPathFormat(String videoPathFormat) {
        this.videoPathFormat = videoPathFormat;
    }

    public String getVideoUrlPrefix() {
        return videoUrlPrefix;
    }

    public void setVideoUrlPrefix(String videoUrlPrefix) {
        this.videoUrlPrefix = videoUrlPrefix;
    }

    public long getVideoMaxSize() {
        return videoMaxSize;
    }

    public void setVideoMaxSize(long videoMaxSize) {
        this.videoMaxSize = videoMaxSize;
    }

    public String getVideoAllowFiles() {
        return videoAllowFiles;
    }

    public void setVideoAllowFiles(String videoAllowFiles) {
        this.videoAllowFiles = videoAllowFiles;
    }

    public String getFileActionName() {
        return fileActionName;
    }

    public void setFileActionName(String fileActionName) {
        this.fileActionName = fileActionName;
    }

    public String getFileFieldName() {
        return fileFieldName;
    }

    public void setFileFieldName(String fileFieldName) {
        this.fileFieldName = fileFieldName;
    }

    public String getFilePathFormat() {
        return filePathFormat;
    }

    public void setFilePathFormat(String filePathFormat) {
        this.filePathFormat = filePathFormat;
    }

    public String getFileUrlPrefix() {
        return fileUrlPrefix;
    }

    public void setFileUrlPrefix(String fileUrlPrefix) {
        this.fileUrlPrefix = fileUrlPrefix;
    }

    public long getFileMaxSize() {
        return fileMaxSize;
    }

    public void setFileMaxSize(long fileMaxSize) {
        this.fileMaxSize = fileMaxSize;
    }

    public String getFileAllowFiles() {
        return fileAllowFiles;
    }

    public void setFileAllowFiles(String fileAllowFiles) {
        this.fileAllowFiles = fileAllowFiles;
    }

    public String getImageManagerActionName() {
        return imageManagerActionName;
    }

    public void setImageManagerActionName(String imageManagerActionName) {
        this.imageManagerActionName = imageManagerActionName;
    }

    public String getImageManagerListPath() {
        return imageManagerListPath;
    }

    public void setImageManagerListPath(String imageManagerListPath) {
        this.imageManagerListPath = imageManagerListPath;
    }

    public long getImageManagerListSize() {
        return imageManagerListSize;
    }

    public void setImageManagerListSize(long imageManagerListSize) {
        this.imageManagerListSize = imageManagerListSize;
    }

    public String getImageManagerUrlPrefix() {
        return imageManagerUrlPrefix;
    }

    public void setImageManagerUrlPrefix(String imageManagerUrlPrefix) {
        this.imageManagerUrlPrefix = imageManagerUrlPrefix;
    }

    public String getImageManagerInsertAlign() {
        return imageManagerInsertAlign;
    }

    public void setImageManagerInsertAlign(String imageManagerInsertAlign) {
        this.imageManagerInsertAlign = imageManagerInsertAlign;
    }

    public String getImageManagerAllowFiles() {
        return imageManagerAllowFiles;
    }

    public void setImageManagerAllowFiles(String imageManagerAllowFiles) {
        this.imageManagerAllowFiles = imageManagerAllowFiles;
    }

    public String getFileManagerActionName() {
        return fileManagerActionName;
    }

    public void setFileManagerActionName(String fileManagerActionName) {
        this.fileManagerActionName = fileManagerActionName;
    }

    public String getFileManagerListPath() {
        return fileManagerListPath;
    }

    public void setFileManagerListPath(String fileManagerListPath) {
        this.fileManagerListPath = fileManagerListPath;
    }

    public String getFileManagerUrlPrefix() {
        return fileManagerUrlPrefix;
    }

    public void setFileManagerUrlPrefix(String fileManagerUrlPrefix) {
        this.fileManagerUrlPrefix = fileManagerUrlPrefix;
    }

    public long getFileManagerListSize() {
        return fileManagerListSize;
    }

    public void setFileManagerListSize(long fileManagerListSize) {
        this.fileManagerListSize = fileManagerListSize;
    }

    public String getFileManagerAllowFiles() {
        return fileManagerAllowFiles;
    }

    public void setFileManagerAllowFiles(String fileManagerAllowFiles) {
        this.fileManagerAllowFiles = fileManagerAllowFiles;
    }

    public File getRootPath() {
        return rootPath;
    }

    public void setRootPath(File rootPath) {
        this.rootPath = rootPath;
    }

    public List<String> from(String src) {
        if (src == null)
            return null;
        return ListUtil.splitTrimExcludeEmpty(src, ',');
    }

    public List<String> addDot(List<String> list) {
        if (null == list)
            return null;
        List<String> ret = new LinkedList<String>();
        for (String s : list) {
            if (s.length() > 0)
                ret.add("." + s);
        }
        return ret;
    }

    public Map<String, Object> getAllConfig() {
        Map<String, Object> ret = new HashMap<String, Object>();
        ret.put("imageActionName", this.imageActionName);
        ret.put("imageFieldName", this.imageFieldName);
        ret.put("imageMaxSize", this.imageMaxSize);
        ret.put("imageAllowFiles", this.addDot(this.from(this.imageAllowFiles)));
        ret.put("imageCompressEnable", this.imageCompressEnable);
        ret.put("imageCompressBorder", this.imageCompressBorder);
        ;
        ret.put("imageInsertAlign", this.imageInsertAlign);
        ret.put("imageUrlPrefix", this.imageUrlPrefix);

        ret.put("imagePathFormat", this.imagePathFormat);

        ret.put("scrawlActionName", this.scrawlActionName);

        ret.put("scrawlFieldName", this.scrawlFieldName);
        ret.put("scrawlPathFormat", this.scrawlPathFormat);
        ret.put("scrawlMaxSize", this.scrawlMaxSize);
        ret.put("scrawlUrlPrefix", this.scrawlUrlPrefix);
        ret.put("scrawlInsertAlign", this.scrawlInsertAlign);

        ret.put("snapscreenActionName", this.snapscreenActionName);
        /* 上传保存路径,可以自定义保存路径和文件名格式 */
        ret.put("snapscreenPathFormat", this.snapscreenPathFormat);
        /* 图片访问路径前缀 */
        ret.put("snapscreenUrlPrefix", this.snapscreenUrlPrefix);
        /* 插入的图片浮动方式 */
        ret.put("snapscreenInsertAlign", this.snapscreenInsertAlign);

        /* 抓取远程图片配置 */
        ret.put("catcherLocalDomain", this.from(this.catcherLocalDomain));
        /* 执行抓取远程图片的action名称 */
        ret.put("catcherActionName", this.catcherActionName);
        /* 提交的图片列表表单名称 */
        ret.put("catcherFieldName", this.catcherFieldName);
        /* 上传保存路径,可以自定义保存路径和文件名格式 */
        ret.put("catcherPathFormat", this.catcherPathFormat);
        /* 图片访问路径前缀 */
        ret.put("catcherUrlPrefix", this.catcherUrlPrefix);
        /* 上传大小限制，单位B */
        ret.put("catcherMaxSize", this.catcherMaxSize);
        ret.put("catcherAllowFiles", this.addDot(this.from(this.catcherAllowFiles)));

        /* 上传视频配置 */
        /* 执行上传视频的action名称 */
        ret.put("videoActionName", this.videoActionName);
        /* 提交的视频表单名称 */
        ret.put("videoFieldName", this.videoFieldName);
        /* 上传保存路径,可以自定义保存路径和文件名格式 */
        ret.put("videoPathFormat", this.videoPathFormat);
        /* 视频访问路径前缀 */
        ret.put("videoUrlPrefix", this.videoUrlPrefix);
        ret.put("videoMaxSize", this.videoMaxSize);
        /* 上传视频格式显示 */
        ret.put("videoAllowFiles", this.addDot(this.from(this.videoAllowFiles)));

        /* 上传文件配置 */
        /* controller里,执行上传视频的action名称 */
        ret.put("fileActionName", this.fileActionName);
        /* 提交的文件表单名称 */
        ret.put("fileFieldName", this.fileFieldName);
        /* 上传保存路径,可以自定义保存路径和文件名格式 */
        ret.put("filePathFormat", this.filePathFormat);
        /* 文件访问路径前缀 */
        ret.put("fileUrlPrefix", this.fileUrlPrefix);
        /* 上传大小限制，单位B，默认50MB */
        ret.put("fileMaxSize", this.fileMaxSize);
        /* 上传文件格式显示 */
        ret.put("fileAllowFiles", this.addDot(this.from(this.fileAllowFiles)));

        /* 列出指定目录下的图片 */
        /* 执行图片管理的action名称 */
        ret.put("imageManagerActionName", this.imageManagerActionName);
        /* 指定要列出图片的目录 */
        ret.put("imageManagerListPath", this.imageManagerListPath);
        /* 每次列出文件数量 */
        ret.put("imageManagerListSize", this.imageManagerListSize);
        /* 图片访问路径前缀 */
        ret.put("imageManagerUrlPrefix", this.imageManagerUrlPrefix);
        /* 插入的图片浮动方式 */
        ret.put("imageManagerInsertAlign", this.imageManagerInsertAlign);
        /* 列出的文件类型 */
        ret.put("imageManagerAllowFiles", this.addDot(this.from(this.imageManagerAllowFiles)));

        /* 列出指定目录下的文件 */
        /* 执行文件管理的action名称 */
        ret.put("fileManagerActionName", this.fileManagerActionName);
        /* 指定要列出文件的目录 */
        ret.put("fileManagerListPath", this.fileManagerListPath);
        /* 文件访问路径前缀 */
        ret.put("fileManagerUrlPrefix", this.fileManagerUrlPrefix);
        /* 每次列出文件数量 */

        ret.put("fileManagerListSize", this.fileManagerListSize);
        /* 列出的文件类型 */
        ret.put("fileManagerAllowFiles", this.addDot(this.from(this.fileManagerAllowFiles)));
        return ret;

    }
}
