package com.ekexiu.portal.msg;

import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.core.enums.DE;


@PrimaryKey({"owner","actor"})
@Table
public class WebMsgIdx {
	
	private String owner;
	private String  actor;
	private long lastTime;
	private int numOfOwner;
	private int numOfActor;
	private String lastCnt;
	private boolean showOfOwner;
	private boolean showOfActor;
	
	
	/**
	 * 所有者(两个ID相比小的是Owner)
	 * @return
	 */
	@Column(DE.text_de)
	public String getOwner() {
		return owner;
	}
	public void setOwner(String owner) {
		this.owner = owner;
	}
	/**
	 *参与者
	 * @return
	 */
	@Column(DE.text_de)
	public String getActor() {
		return actor;
	}
	public void setActor(String actor) {
		this.actor = actor;
	}
	/**
	 * 最后发送时间
	 * @return
	 */
	@Column(DE.long_de)
	public long getLastTime() {
		return lastTime;
	}
	public void setLastTime(long lastTime) {
		this.lastTime = lastTime;
	}
	/**
	 * 未读信息数(所有者)
	 * @return
	 */
	@Column(DE.int_de)
	public int getNumOfOwner() {
		return numOfOwner;
	}
	public void setNumOfOwner(int num) {
		this.numOfOwner = num;
	}
	
	
	/**
	 * 未读信息数(参有者)
	 * @return
	 */
	@Column(DE.int_de)
	public int getNumOfActor() {
		return numOfActor;
	}
	public void setNumOfActor(int numOfActor) {
		this.numOfActor = numOfActor;
	}
	/**
	 * 最后信息内容
	 * @return
	 */
	@Column(DE.text_de)
	public String getLastCnt() {
		return lastCnt;
	}
	public void setLastCnt(String lastCnt) {
		this.lastCnt = lastCnt;
	}
	
	/**
	 * 所有者是否显示（会话在所有者的列表中未被删除）
	 * @return
	 */
	@Column(DE.boolean_de)
	public boolean isShowOfOwner() {
		return showOfOwner;
	}
	public void setShowOfOwner(boolean showOfOwner) {
		this.showOfOwner = showOfOwner;
	}
	/**
	 * 参与者是否显示（会话在参与者的列表中未被删除）
	 * @return
	 */
	@Column(DE.boolean_de)
	public boolean isShowOfActor() {
		return showOfActor;
	}
	public void setShowOfActor(boolean showOfActor) {
		this.showOfActor = showOfActor;
	}
}
