package com.ekexiu.portal.notify;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.DateUtil;
import org.jfw.util.StringUtil;
import org.jfw.util.json.JsonService;

import com.ekexiu.portal.util.WebMsgSocketServlet;
import com.ekexiu.push.service.PushService;

@Path("/notify")
public class NotifyService {

	@Autowrie
	private NotifyMsgDao notifyMsgDao;
	@Autowrie
	private PushService pushService;

	public NotifyMsgDao getNotifyMsgDao() {
		return notifyMsgDao;
	}

	public void setNotifyMsgDao(NotifyMsgDao notifyMsgDao) {
		this.notifyMsgDao = notifyMsgDao;
	}

	public PushService getPushService() {
		return pushService;
	}

	public void setPushService(PushService pushService) {
		this.pushService = pushService;
	}

	public void notify(Connection con, final String rid, String uid, String uname, String pid, String pname, NotifyType type,List<Runnable> runs) throws SQLException {
		String time = DateUtil.formatDateTime(System.currentTimeMillis());
		String id = StringUtil.buildUUID();
		String tCnt = type.format(uname, pname);
		final NotifyMsgCnt cnt = new NotifyMsgCnt();
		cnt.setId(id);
		cnt.setCnt(tCnt);
		cnt.setCreateTime(time);
		cnt.setOpType(type.getType());
		cnt.setPid(pid);
		cnt.setReaded(false);
		cnt.setReciver(rid);
		cnt.setUid(uid);
		cnt.setTimeDesc(time+id);
		notifyMsgDao.insert(con, cnt);
		final NotifyMsgIdx idx = new NotifyMsgIdx();
		idx.setLastCnt(tCnt);
		idx.setLastTime(time);
		idx.setReciver(rid);
		idx.setUnRead(1);
		if (notifyMsgDao.updateIdx(con, tCnt, time, rid) < 1) {
			notifyMsgDao.insert(con, idx);
		}

		final Runnable ret = new Runnable() {
			public void run() {
				WebMsgSocketServlet.sendMessage(rid, JsonService.toJson(cnt));
				try {
					pushService.pushWithAlias("通知", "您收到了一条通知", "msgsend", rid);
				} catch (Throwable thr) {
				}
			}
		};
		runs.add(ret);
	}

	@Path("/idx")
	@Get
	public NotifyMsgIdx query(@JdbcConn Connection con, String id) throws SQLException {
		return notifyMsgDao.queryIdx(con, id);
	}

	@Path()
	@Get
	public List<NotifyMsgCnt> query(@JdbcConn Connection con, String uid, @DefaultValue("\"99999999999999\"") String time, @DefaultValue("\"0\"") String mid,
			@DefaultValue("20") int rows) throws SQLException {
		return notifyMsgDao.queryCnt(con, uid, time+mid, rows);
	}
	@Post
	@Path("/readed")
	public int read(@JdbcConn(true) Connection con,String uid,String time,String mid)throws SQLException{
		int num = this.notifyMsgDao.readed(con, uid,time+mid);
		if(num>0){
			this.notifyMsgDao.decUnRead(con, uid,num);
		}
		return num;
	}
}
