package com.ekexiu.portal.platform;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicInteger;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.method.SetCookie;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.FieldParam;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.RequestParam;
import org.jfw.apt.web.annotation.param.Upload;
import org.jfw.util.JpgUtil;
import org.jfw.util.PageQueryResult;
import org.jfw.util.StringUtil;
import org.jfw.util.context.JfwAppContext;
import org.jfw.util.exception.JfwBaseException;
import org.jfw.util.io.IoUtil;
import org.jfw.util.state.StateCode;
import org.jfw.util.web.fileupload.Item;
import org.jfw.util.web.fileupload.UploadItemIterator;

import com.ekexiu.portal.mail.MailService;
import com.ekexiu.portal.service.ImageService;

@Path("/platform")
public class PlatformService {
	private static final AtomicInteger FN_IDX = new AtomicInteger(1);

	private long restPasswordWithEmailTimeout = 60 * 10;

	private String urlWithRestPasswordWithEmail = "MAIL_REST_URL";
	private String stateCodeWithRestPasswordWithEmail = "MAIL_REST_SC";
	private String templateWithRestPasswordWithEmail = "";
	private String subjectWithRestPasswordWithEmail = "「科袖」平台账户密码找回";

	private long bindEmailTimeout = 60 * 10;

	private String urlWithBindEmail = "MAIL_BIND_URL";
	private String stateCodeWithBindEmail = "MAIL_BIND_SC";
	private String templateWithBindEmail = "";
	private String subjectWithBindEmail = "「科袖」平台账户邮箱绑定";

	@Autowrie
	private PlatformDao platformDao;

	@Autowrie
	private MailService mailService;

	private File imgPath;

	private int imgMaxWidth = 70;

	@Autowrie
	private ImageService imageService;

	public ImageService getImageService() {
		return imageService;
	}

	public void setImageService(ImageService imageService) {
		this.imageService = imageService;
	}

	public int getImgMaxWidth() {
		return imgMaxWidth;
	}

	public void setImgMaxWidth(int imgMaxWidth) {
		this.imgMaxWidth = imgMaxWidth;
	}

	public File getImgPath() {
		return imgPath;
	}

	public void setImgPath(File imgPath) {
		this.imgPath = imgPath;
	}

	public PlatformDao getPlatformDao() {
		return platformDao;
	}

	public void setPlatformDao(PlatformDao platformDao) {
		this.platformDao = platformDao;
	}

	public MailService getMailService() {
		return mailService;
	}

	public void setMailService(MailService mailService) {
		this.mailService = mailService;
	}
	
	

	public String getUrlWithRestPasswordWithEmail() {
		return urlWithRestPasswordWithEmail;
	}

	public void setUrlWithRestPasswordWithEmail(String urlWithRestPasswordWithEmail) {
		this.urlWithRestPasswordWithEmail = urlWithRestPasswordWithEmail;
	}

	public String getStateCodeWithRestPasswordWithEmail() {
		return stateCodeWithRestPasswordWithEmail;
	}

	public void setStateCodeWithRestPasswordWithEmail(String stateCodeWithRestPasswordWithEmail) {
		this.stateCodeWithRestPasswordWithEmail = stateCodeWithRestPasswordWithEmail;
	}

	public String getTemplateWithRestPasswordWithEmail() {
		return templateWithRestPasswordWithEmail;
	}

	public void setTemplateWithRestPasswordWithEmail(String templateWithRestPasswordWithEmail) {
		this.templateWithRestPasswordWithEmail = templateWithRestPasswordWithEmail;
	}

	public String getSubjectWithRestPasswordWithEmail() {
		return subjectWithRestPasswordWithEmail;
	}

	public void setSubjectWithRestPasswordWithEmail(String subjectWithRestPasswordWithEmail) {
		this.subjectWithRestPasswordWithEmail = subjectWithRestPasswordWithEmail;
	}

	public String getUrlWithBindEmail() {
		return urlWithBindEmail;
	}

	public void setUrlWithBindEmail(String urlWithBindEmail) {
		this.urlWithBindEmail = urlWithBindEmail;
	}

	public String getStateCodeWithBindEmail() {
		return stateCodeWithBindEmail;
	}

	public void setStateCodeWithBindEmail(String stateCodeWithBindEmail) {
		this.stateCodeWithBindEmail = stateCodeWithBindEmail;
	}

	public String getTemplateWithBindEmail() {
		return templateWithBindEmail;
	}

	public void setTemplateWithBindEmail(String templateWithBindEmail) {
		this.templateWithBindEmail = templateWithBindEmail;
	}

	public String getSubjectWithBindEmail() {
		return subjectWithBindEmail;
	}

	public void setSubjectWithBindEmail(String subjectWithBindEmail) {
		this.subjectWithBindEmail = subjectWithBindEmail;
	}

	@SetCookie(checkResultNull = true, path = "/", value = { "plf_user=result.getId()", "plf_email=result.getEmail()",
			"plf_logo=result.getLogo()==null?\"\":result.getLogo()", "plf_name=result.getName()" })
	@Post
	@Path("/login")
	public LoginUserInfo login(@JdbcConn Connection con, String email, String pw) throws JfwBaseException, SQLException {
		LoginUserInfo ret = null;
		PlatformUser pu = this.platformDao.queryUser(con, email);
		if (pu != null) {
			if (!"1".equals(pu.getState())) {
				throw new JfwBaseException(-600004, "user disabled");
			}
			if (StringUtil.md5(pw).equals(pu.getPasswd())) {
				PlatformInfo pi = this.platformDao.queryInfo(con, pu.getId());
				if (pi != null) {
					ret = new LoginUserInfo();
					ret.setEmail(email);
					ret.setId(pu.getId());
					ret.setLogo(pi.getLogo());
					ret.setName(pi.getName());
				} else {
					throw new JfwBaseException(-600003, "user info not exists");
				}
			} else {
				throw new JfwBaseException(-600002, "invalid login param");
			}
		} else {
			throw new JfwBaseException(-600001, "not found user");
		}
		return ret;
	}

	@Path("/reqResetPw")
	@Post
	public void requestResetPasswordWithEmail(@JdbcConn Connection con, String mail,String url) throws SQLException, JfwBaseException {
		PlatformUser pu = this.platformDao.queryUser(con, mail);
		if (pu == null)
			throw new JfwBaseException(-600001, "not found user");
		StateCode<String, String> sc = new StateCode<String, String>();
		sc.setCode(pu.getId());
		sc.setKey(pu.getEmail());
		sc.setValue(pu.getPasswd());

		final String cachekey = JfwAppContext.cacheObjectAndGenKey(sc);
		Map<String, String> mailParam = new HashMap<String, String>();
		mailParam.put(this.stateCodeWithRestPasswordWithEmail, cachekey);
		mailParam.put(this.urlWithRestPasswordWithEmail, url);
		try {
			mailService.sendSimpleMail(mail, this.templateWithRestPasswordWithEmail, mailParam, this.subjectWithRestPasswordWithEmail);
			JfwAppContext.getScheduledExecutorService().schedule(new Runnable() {

				@Override
				public void run() {
					JfwAppContext.removeCachedObject(cachekey);
				}
			}, this.restPasswordWithEmailTimeout, TimeUnit.SECONDS);
		} catch (Exception e) {
			JfwAppContext.removeCachedObject(cachekey);
			throw new JfwBaseException(-600002, "mail service error");
		}
	}

	@Post
	@Path("/resetpw")
	public void restpw(@JdbcConn(true) Connection con, String code, String pw) throws SQLException, JfwBaseException {
		@SuppressWarnings("unchecked")
		StateCode<String, String> sc = (StateCode<String, String>) JfwAppContext.getCachedObject(code);
		if (sc == null) {
			throw new JfwBaseException(-600001, " code expire");
		}
		JfwAppContext.removeCachedObject(code);
		pw = StringUtil.md5(pw);
		if (this.platformDao.updatePasswd(con, sc.getCode(), sc.getKey(), sc.getValue(), pw) == 0) {
			throw new JfwBaseException(-600002, "user too fresh");
		}
	}

	@Path("/reqBindMail")
	@Post
	public void requestBindMail(@JdbcConn Connection con, String mail, String id, String url) throws SQLException, JfwBaseException {
		PlatformUser pu = this.platformDao.queryUser(con, mail);
		if (pu != null)
			throw new JfwBaseException(-600001, "already bind");
		pu = this.platformDao.queryUserById(con, id);
		if (pu == null)
			throw new JfwBaseException(-600002, "not exists user[" + id + "]");

		StateCode<String, String> sc = new StateCode<String, String>();
		sc.setCode(pu.getId());
		sc.setKey(pu.getEmail());
		sc.setValue(pu.getPasswd());
		sc.setDescp(mail);

		final String cachekey = JfwAppContext.cacheObjectAndGenKey(sc);
		Map<String, String> mailParam = new HashMap<String, String>();
		mailParam.put(this.stateCodeWithBindEmail, cachekey);

		mailParam.put(this.urlWithBindEmail, url);
		try {
			mailService.sendSimpleMail(mail, this.templateWithBindEmail, mailParam, this.subjectWithBindEmail);
			JfwAppContext.getScheduledExecutorService().schedule(new Runnable() {
				@Override
				public void run() {
					JfwAppContext.removeCachedObject(cachekey);
				}
			}, this.bindEmailTimeout, TimeUnit.SECONDS);
		} catch (Exception e) {
			JfwAppContext.removeCachedObject(cachekey);
			throw new JfwBaseException(-600003, "mail service error");
		}
	}

	@Post
	@Path("/bindMail")
	public void bindMail(@JdbcConn(true) Connection con, String code) throws SQLException, JfwBaseException {
		@SuppressWarnings("unchecked")
		StateCode<String, String> sc = (StateCode<String, String>) JfwAppContext.getCachedObject(code);
		if (sc == null) {
			throw new JfwBaseException(-600001, " code expire");
		}
		JfwAppContext.removeCachedObject(code);

		if (this.platformDao.updateMail(con, sc.getCode(), sc.getKey(), sc.getValue(), sc.getDescp()) == 0) {
			throw new JfwBaseException(-600002, "user too fresh");
		}
	}

	@Post
	@Path("/modifypw")
	public int modifypw(@JdbcConn(true) Connection con, String id, String opw, String npw) throws SQLException {
		return this.platformDao.updatePasswd(con, id, StringUtil.md5(opw), StringUtil.md5(npw));
	}

	@Post
	@Path("/info")
	public int updateInfo(@JdbcConn(true) Connection con, @RequestParam(excludeFields = { "createTime", "modifyTime" }) PlatformInfo pi) throws SQLException {
		return this.platformDao.update(con, pi);
	}

	@Get
	@Path("/info")
	public PlatformInfo info(@JdbcConn Connection con, String id) throws SQLException {
		return this.platformDao.queryInfo(con, id);
	}

	@Post
	@Path("/add/org")
	public int addOrg(@JdbcConn(true) Connection con, @RequestParam(excludeFields = { "createTime", "id" }) PlatformOrg po) throws SQLException {
		po.setId(StringUtil.buildUUID());
		return this.platformDao.insert(con, po);
	}

	@Post
	@Path("/resident")
	public int resident(@JdbcConn(true) Connection con, @RequestParam(fields = { @FieldParam(value = "pid", valueClass = String.class),
			@FieldParam(value = "oid", valueClass = String.class) }) ResidentOrg po) throws SQLException {
		return this.platformDao.insert(con, po);
	}

	@Post
	@Path("/buttedOrg")
	public int buttedOrg(@JdbcConn(true) Connection con, @RequestParam(fields = { @FieldParam(value = "pid", valueClass = String.class),
			@FieldParam(value = "oid", valueClass = String.class) }) ButtedOrg po) throws SQLException {
		return this.platformDao.insert(con, po);
	}

	@Post
	@Path("/buttedProfessor")
	public int buttedProfessor(@JdbcConn(true) Connection con, @RequestParam(fields = { @FieldParam(value = "pid", valueClass = String.class),
			@FieldParam(value = "uid", valueClass = String.class) }) ButtedProfessor po) throws SQLException {
		return this.platformDao.insert(con, po);
	}

	@Post
	@Path("/referencedArticle")
	public int referencedArticle(@JdbcConn(true) Connection con, @RequestParam(fields = { @FieldParam(value = "pid", valueClass = String.class),
			@FieldParam(value = "aid", valueClass = String.class) }) ReferencedArticle po) throws SQLException {
		return this.platformDao.insert(con, po);
	}

	@Post
	@Path("/resident/delete")
	public int residentDelete(@JdbcConn(true) Connection con, @RequestParam(fields = { @FieldParam(value = "pid", valueClass = String.class),
			@FieldParam(value = "oid", valueClass = String.class) }) ResidentOrg po) throws SQLException {
		return this.platformDao.delete(con, po);
	}

	@Post
	@Path("/buttedOrg/delete")
	public int buttedOrgDelete(@JdbcConn(true) Connection con, @RequestParam(fields = { @FieldParam(value = "pid", valueClass = String.class),
			@FieldParam(value = "oid", valueClass = String.class) }) ButtedOrg po) throws SQLException {
		return this.platformDao.delete(con, po);
	}

	@Post
	@Path("/buttedProfessor/delete")
	public int buttedProfessorDelete(@JdbcConn(true) Connection con, @RequestParam(fields = { @FieldParam(value = "pid", valueClass = String.class),
			@FieldParam(value = "uid", valueClass = String.class) }) ButtedProfessor po) throws SQLException {
		return this.platformDao.delete(con, po);
	}

	@Post
	@Path("/referencedArticle/delete")
	public int referencedArticleDelete(@JdbcConn(true) Connection con, @RequestParam(fields = { @FieldParam(value = "pid", valueClass = String.class),
			@FieldParam(value = "aid", valueClass = String.class) }) ReferencedArticle po) throws SQLException {
		return this.platformDao.delete(con, po);
	}

	@Get
	@Path("/info/residentOrgs")
	public List<ResidentOrgInfo> queryResidentOrginfos(@JdbcConn Connection con, @DefaultValue("\"z\"") String time, @DefaultValue("\"z\"") String oid,
			String pid, @Nullable String key, int rows) throws SQLException {

		List<ResidentOrgInfo> ret = this.platformDao.queryResientOrgInfo(con, time, oid, pid, key == null ? null : ("%" + key + "%"), rows);
		for (ResidentOrgInfo roi : ret) {
			roi.setHasOrgLogo(this.imageService.hasOrgLogo(roi.getId()));
		}
		return ret;
	}

	@Get
	@Path("/info/buttedOrgs")
	public List<ButtedOrgInfo> queryButtedOrginfos(@JdbcConn Connection con, @DefaultValue("\"z\"") String time, @DefaultValue("\"z\"") String oid, String pid,
			int rows) throws SQLException {

		List<ButtedOrgInfo> ret = this.platformDao.queryButtedOrgInfo(con, time, oid, pid, rows);
		for (ButtedOrgInfo roi : ret) {
			roi.setHasOrgLogo(this.imageService.hasOrgLogo(roi.getId()));
		}
		return ret;
	}

	@Get
	@Path("/info/pqButtedOrgs")
	public PageQueryResult<ButtedOrgInfo> pqButtedOrginfos(@JdbcConn Connection con, String pid, int pageSize, int pageNo) throws SQLException {

		PageQueryResult<ButtedOrgInfo> ret = this.platformDao.pageQueryButtedOrgInfo(con, pid, pageSize, pageNo);
		for (ButtedOrgInfo roi : ret.getData()) {
			roi.setHasOrgLogo(this.imageService.hasOrgLogo(roi.getId()));
		}
		return ret;
	}

	@Get
	@Path("/info/buttedProfessors")
	public List<ButtedProfessorInfo> queryButtedProfessorinfos(@JdbcConn Connection con, @DefaultValue("\"z\"") String time, @DefaultValue("\"z\"") String uid,
			String pid, int rows) throws SQLException {

		List<ButtedProfessorInfo> ret = this.platformDao.queryButtedProfessorInfo(con, time, uid, pid, rows);
		for (ButtedProfessorInfo roi : ret) {
			roi.setHasHeadImage(this.imageService.hasProfessorImage(roi.getId()));
		}
		return ret;
	}

	@Get
	@Path("/info/pqButtedProfessors")
	public PageQueryResult<ButtedProfessorInfo> pageQueryButtedProfessorinfos(@JdbcConn Connection con, String pid, int pageSize, int pageNo)
			throws SQLException {
		PageQueryResult<ButtedProfessorInfo> ret = this.platformDao.queryButtedProfessorInfo(con, pid, pageSize, pageNo);
		for (ButtedProfessorInfo roi : ret.getData()) {
			roi.setHasHeadImage(this.imageService.hasProfessorImage(roi.getId()));
		}
		return ret;
	}

	@Post
	@Path("/upload")
	public List<UploadFile> upload(@Upload UploadItemIterator it) throws Exception {
		List<UploadFile> ret = new LinkedList<UploadFile>();
		try {
			while (it.hasNext()) {
				Item item = it.next();
				if (!item.isFormField()) {
					String name = normalizeFileName(item.getName());
					int index = name.lastIndexOf('.');
					String ext = index >= 0 ? name.substring(index + 1) : "";
					ext = ext.trim();
					long fileLen = 0;
					int len = 0;
					UploadFile uf = this.buildTargetFile(ext);
					uf.setName(name);
					File file = uf.getFn();
					ret.add(uf);
					byte[] buf = new byte[8092];
					OutputStream of = new FileOutputStream(file);
					try {
						InputStream in = item.getInputStream();
						try {
							while ((len = in.read(buf)) >= 0) {
								if (len > 0) {
									of.write(buf, 0, len);
									fileLen += len;
								}
							}
							uf.setSize(fileLen);
						} finally {
							in.close();
						}
					} finally {
						of.close();
					}
					this.saveSmallImg(uf.getUri().substring(1));
				}
			}
			return ret;
		} catch (Exception e) {
			this.remove(ret);
			throw e;
		} finally {
			if (it != null)
				it.clean();
		}
	}

	private void remove(List<UploadFile> list) {
		for (UploadFile file : list) {
			if (file.fn != null)
				file.fn.delete();
		}
	}

	private void saveSmallImg(String img) throws IOException {
		int idx = img.indexOf('.');
		if (idx > 0) {
			String dname = img.substring(0, idx) + "_s.jpg";
			File dest = new File(this.imgPath, dname);
			if (dest.exists())
				return;
			File src = new File(this.imgPath, img);
			byte[] obs = IoUtil.readStream(new FileInputStream(src), true);
			obs = JpgUtil.read(obs);
			FileOutputStream out = new FileOutputStream(dest);
			try {
				JpgUtil.scalingZoom(new ByteArrayInputStream(obs), out, this.imgMaxWidth);
				out.flush();
			} finally {
				IoUtil.close(out);
			}
		}

	}

	private UploadFile buildTargetFile(String ext) {
		StringBuilder sb = new StringBuilder();
		sb.append(System.currentTimeMillis() / (1000 * 60 * 60 * 24));
		File path = new File(this.imgPath, sb.toString());
		if (!path.exists()) {
			synchronized (this) {
				if (!path.mkdirs())
					throw new RuntimeException("mkdir error[" + path + "]");
				FN_IDX.set(1);
			}
		}
		File file;
		do {
			String fn = FN_IDX.toString();
			if (ext.isEmpty()) {
				file = new File(path, fn);
			} else {
				file = new File(path, fn + "." + ext);
			}
			FN_IDX.incrementAndGet();
		} while (file.exists());
		sb.append("/").append(file.getName());
		UploadFile uf = new UploadFile();
		uf.setFn(file);
		uf.setUri("/" + sb.toString());
		return uf;
	}

	private String normalizeFileName(String fn) {
		int index = fn.indexOf('\\');
		if (index >= 0) {
			fn = fn.substring(fn.lastIndexOf('\\') + 1);
		}
		index = fn.indexOf('/');
		if (index >= 0) {
			fn = fn.substring(fn.lastIndexOf('/') + 1);
		}
		if (fn.length() == 0)
			throw new RuntimeException("invalid filename in Multipart/data request");
		return fn;
	}

	public static class UploadFile {
		private String name;
		private String uri;
		private long size;
		private transient File fn;

		public File getFn() {
			return fn;
		}

		public void setFn(File fn) {
			this.fn = fn;
		}

		public String getName() {
			return name;
		}

		public void setName(String name) {
			this.name = name;
		}

		public String getUri() {
			return uri;
		}

		public void setUri(String uri) {
			this.uri = uri;
		}

		public long getSize() {
			return size;
		}

		public void setSize(long size) {
			this.size = size;
		}
	}

}
