package com.ekexiu.portal.po;

import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.annotation.entry.Unique;
import org.jfw.apt.orm.annotation.entry.Uniques;
import org.jfw.apt.orm.core.defaultImpl.BooleanHandler;
import org.jfw.apt.orm.core.defaultImpl.FixLenStringHandler;
import org.jfw.apt.orm.core.defaultImpl.LongHandler;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.apt.orm.core.enums.DE;

import com.ekexiu.portal.basepo.BaseOrganization;
import com.ekexiu.portal.basepo.CreateTimeSupported;
import com.ekexiu.portal.basepo.DescpSupported;
import com.ekexiu.portal.basepo.ModifyTimeSupported;

@Uniques(@Unique(name="ORGANIZATION_NAME_UN",clolumns="name"))
@PrimaryKey("id")
@Table
public class Organization extends BaseOrganization implements CreateTimeSupported,ModifyTimeSupported,DescpSupported{

	/**
	 * 企业简称
	 */
	private String forShort;
	/**
	 * 企业官网
	 */
	private String orgUrl;
	/**
	 * 创立时间
	 */
	private String foundTime;
	private String province;
	private String city;
	private String subject;
	private String industry;
	/**
	 * 企业规模
	 */
	private String orgSize;
	/**
	 * 企业资质
	 */
	private String qualification;
	/**
	 * 是否入驻
	 */
	private String isJoin;
	/**
	 * 认证状态
	 */
	private String authStatus;
	private String descp;
	private String createTime;
	private String modifyTime;
	
	/**
	 * 详细地址
	 */
	private String addr;
	/**
	 * 联系邮箱
	 */
	private String email;
	/**
	 * 联系电话
	 */
	private String contactNum;
	/**
	 * 客户领域
	 */
	private String fieldOfCustomer;
	/**
	 * 供应商领域
	 */
	private String fieldOfSupplier;
	/**
	 * 排序字段
	 */
	private long sortNum;
	/**
	 * 浏览量
	 */
	private long pageViews;
	private long shareId;
	private boolean colMgr;
	private boolean resMgr;
	

	@Column(value=DE.String_de,dbType="VARCHAR(20)")
	public String getForShort() {
		return forShort;
	}
	public void setForShort(String forShort) {
		this.forShort = forShort;
	}
	@Column(DE.String_de)
	public String getOrgUrl() {
		return orgUrl;
	}
	public void setOrgUrl(String orgUrl) {
		this.orgUrl = orgUrl;
	}
	@Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(8)",nullable=true,insertable=true,renewable=true,queryable=true)
	public String getFoundTime() {
		return foundTime;
	}
	public void setFoundTime(String foundTime) {
		this.foundTime = foundTime;
	}
	@Column(DE.String_de)
	public String getProvince() {
		return province;
	}
	public void setProvince(String province) {
		this.province = province;
	}
	@Column(DE.String_de)
	public String getCity() {
		return city;
	}
	public void setCity(String city) {
		this.city = city;
	}
	@Column(value=DE.String_de,dbType="TEXT")
	public String getSubject() {
		return subject;
	}
	public void setSubject(String subject) {
		this.subject = subject;
	}
	@Column(value=DE.String_de,dbType="TEXT")
	public String getIndustry() {
		return industry;
	}
	public void setIndustry(String industry) {
		this.industry = industry;
	}
	@Column(DE.SingleChar)
	public String getOrgSize() {
		return orgSize;
	}
	public void setOrgSize(String orgSize) {
		this.orgSize = orgSize;
	}
	@Column(value=DE.String_de,dbType="TEXT")
	public String getQualification() {
		return qualification;
	}
	public void setQualification(String qualification) {
		this.qualification = qualification;
	}
	@Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(1)",renewable=false)
	public String getIsJoin() {
		return isJoin;
	}
	public void setIsJoin(String isJoin) {
		this.isJoin = isJoin;
	}
	@Column(handlerClass=StringHandler.class,dbType="VARCHAR(2)",renewable=false)
	public String getAuthStatus() {
		return authStatus;
	}
	public void setAuthStatus(String authStatus) {
		this.authStatus = authStatus;
	}
	public String getDescp() {
		return descp;
	}
	public void setDescp(String descp) {
		this.descp = descp;
	}
	public String getCreateTime() {
		return createTime;
	}
	public void setCreateTime(String createTime) {
		this.createTime = createTime;
	}
	public String getModifyTime() {
		return modifyTime;
	}
	public void setModifyTime(String modifyTime) {
		this.modifyTime = modifyTime;
	}
	@Column(DE.Text_de)
	public String getAddr() {
		return addr;
	}
	public void setAddr(String addr) {
		this.addr = addr;
	}
	@Column(DE.Text_de)
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	@Column(DE.Text_de)
	public String getContactNum() {
		return contactNum;
	}
	public void setContactNum(String contactNum) {
		this.contactNum = contactNum;
	}
	@Column(DE.Text_de)
	public String getFieldOfCustomer() {
		return fieldOfCustomer;
	}
	public void setFieldOfCustomer(String fieldOfCustomer) {
		this.fieldOfCustomer = fieldOfCustomer;
	}
	@Column(DE.Text_de)
	public String getFieldOfSupplier() {
		return fieldOfSupplier;
	}
	public void setFieldOfSupplier(String fieldOfSupplier) {
		this.fieldOfSupplier = fieldOfSupplier;
	}
	@Column(handlerClass=LongHandler.class,dbType="BIGINT",fixSqlValueWithInsert="0",insertable=true,renewable=false,nullable=false,queryable=true)
	public long getSortNum() {
		return sortNum;
	}
	public void setSortNum(long sortNum) {
		this.sortNum = sortNum;
	}
	@Column(handlerClass=LongHandler.class,dbType="BIGINT",fixSqlValueWithInsert="0",insertable=true,renewable=false,nullable=false,queryable=true)
	public long getPageViews() {
		return pageViews;
	}
	public void setPageViews(long pageViews) {
		this.pageViews = pageViews;
	}
	@Column(DE.bigSerial)
	public long getShareId() {
		return shareId;
	}
	public void setShareId(long shareId) {
		this.shareId = shareId;
	}
	@Column(handlerClass=BooleanHandler.class,dbType="CHAR(1)",fixSqlValueWithInsert="'0'",insertable=true,nullable=false,queryable=true,renewable = false)
	public boolean isColMgr() {
		return colMgr;
	}
	public void setColMgr(boolean colMgr) {
		this.colMgr = colMgr;
	}
	@Column(handlerClass=BooleanHandler.class,dbType="CHAR(1)",fixSqlValueWithInsert="'0'",insertable=true,nullable=false,queryable=true,renewable = false)
	public boolean isResMgr() {
		return resMgr;
	}
	public void setResMgr(boolean resMgr) {
		this.resMgr = resMgr;
	}	
	
}
