package com.ekexiu.portal.po;

import com.ekexiu.portal.basepo.CreateTimeSupported;
import com.ekexiu.portal.basepo.ModifyTimeSupported;

import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.annotation.entry.Unique;
import org.jfw.apt.orm.annotation.entry.Uniques;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.apt.orm.core.enums.DE;

@Table
@PrimaryKey({ "oauthType", "openid", "userid" })
@Uniques({ @Unique(clolumns = { "userid", "oauthType" }, name = "USER_OPEN_ID_UO"), @Unique(clolumns = { "oauthType", "openid" }, name = "USER_OPEN_ID_OO") })
public class UserOpenId implements CreateTimeSupported, ModifyTimeSupported {
    private String createTime;
    private String modifyTime;
    private String userid;
    private String oauthType;
    private String openid;

    @Column(DE.id_32)
    public String getUserid() {
        return this.userid;
    }

    public void setUserid(String userid) {
        this.userid = userid;
    }

    @Column(dbType = "text", handlerClass = StringHandler.class, insertable = true, nullable = false, queryable = true, renewable = true)
    public String getOauthType() {
        return this.oauthType;
    }

    public void setOauthType(String oauthType) {
        this.oauthType = oauthType;
    }

    @Column(dbType = "text", handlerClass = StringHandler.class, insertable = true, nullable = false, queryable = true, renewable = true)
    public String getOpenid() {
        return this.openid;
    }

    public void setOpenid(String openid) {
        this.openid = openid;
    }

    public String getModifyTime() {
        return this.modifyTime;
    }

    public void setModifyTime(String modifyTime) {
        this.modifyTime = modifyTime;
    }

    public String getCreateTime() {
        return this.createTime;
    }

    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }
}
