package com.ekexiu.portal.question;

import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.core.defaultImpl.FixLenStringHandler;
import org.jfw.apt.orm.core.enums.DE;

import com.ekexiu.portal.basepo.ModifyTimeSupported;

@PrimaryKey("id")
@Table
public class Question implements ModifyTimeSupported{
	
	private String id;
	private String title;
	private String cnt;
	private String img;
	private String createTime;
	private String modifyTime;
	private String keys;
	private String uid;	
	private String lastReplyTime;
	private long replyCount;
	private String state;
	private long pageViews;
	private transient String timeDesc;
	
	
	@Column(DE.long_de)
	public long getPageViews() {
		return pageViews;
	}
	public void setPageViews(long pageViews) {
		this.pageViews = pageViews;
	}
	@Column(DE.text_de)
	public String getTimeDesc() {
		return timeDesc;
	}
	public void setTimeDesc(String timeDesc) {
		this.timeDesc = timeDesc;
	}
	/**
	 * ID
	 * @return
	 */
	@Column(DE.id_32)
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	@Column(DE.text_de)
	public String getTitle() {
		return title;
	}
	public void setTitle(String title) {
		this.title = title;
	}
	/**
	 * 提问内容
	 * @return
	 */
	@Column(DE.Text_de)
	public String getCnt() {
		return cnt;
	}
	public void setCnt(String cnt) {
		this.cnt = cnt;
	}
	/**
	 * 图片 用英文豆号分隔
	 * @return
	 */
	@Column(DE.Text_de)
	public String getImg() {
		return img;
	}
	public void setImg(String img) {
		this.img = img;
	}
	@Column(DE.text_de)
	public String getCreateTime() {
		return createTime;
	}
	public void setCreateTime(String createTime) {
		this.createTime = createTime;
	}
	public String getModifyTime() {
		return modifyTime;
	}
	public void setModifyTime(String modifyTime) {
		this.modifyTime = modifyTime;
	}
	/**
	 * 关键词，以英文逗号分隔
	 * @return
	 */
	@Column(DE.text_de)
	public String getKeys() {
		return keys;
	}
	public void setKeys(String keys) {
		this.keys = keys;
	}
	/**
	 * 发布人ID
	 * @return
	 */
	@Column(DE.text_de)
	public String getUid() {
		return uid;
	}
	public void setUid(String uid) {
		this.uid = uid;
	}
	/**
	 * 最后回答时间
	 * @return
	 */
	@Column(handlerClass = FixLenStringHandler.class, dbType = "CHAR(14)", fixSqlValueWithUpdate = "TO_CHAR(NOW(),'YYYYMMDDHH24MISS')", insertable = false, nullable = true, queryable = true, renewable = true)
	public String getLastReplyTime() {
		return lastReplyTime;
	}
	public void setLastReplyTime(String lastReplyTime) {
		this.lastReplyTime = lastReplyTime;
	}
	/**
	 * 回答次数
	 * @return
	 */
	@Column(DE.long_de)
	public long getReplyCount() {
		return replyCount;
	}
	public void setReplyCount(long replyCount) {
		this.replyCount = replyCount;
	}
	/**
	 * 提问状态  1：发布中
	 * @return
	 */
	@Column(DE.singleChar)
	public String getState() {
		return state;
	}
	public void setState(String state) {
		this.state = state;
	}
	
}
