package com.ekexiu.portal.service;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.StringUtil;

import com.ekexiu.portal.dao.ComplainDao;
import com.ekexiu.portal.po.Complain;

@Path("/complain")
public class ComplainService {
	@Autowrie
	private ComplainDao complainDao;

	public ComplainDao getComplainDao() {
		return complainDao;
	}

	public void setComplainDao(ComplainDao complainDao) {
		this.complainDao = complainDao;
	}
	
	@Post
	@Path
	public String insert(@JdbcConn(true) Connection con, Complain complain) throws SQLException{
		String complainId = StringUtil.buildUUID();
		complain.setComplainId(complainId);
		this.complainDao.insert(con, complain);
		return complainId;
	}
	
	@Get
	@Path("/qa")
	public List<Complain> query(@JdbcConn Connection con, @Nullable Integer complainType) throws SQLException{
		return this.complainDao.query(con, complainType);
	}
	
	@Get
	@Path("/qaPro")
	public List<Complain> queryPro(@JdbcConn Connection con, String professorId) throws SQLException{
		return this.complainDao.queryPro(con, professorId);
	}
	
}
