package com.ekexiu.portal.service;

import java.sql.Connection;
import java.sql.SQLException;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;

import com.ekexiu.portal.dao.FeedbackDao;
import com.ekexiu.portal.po.Feedback;

@Path("/feedback")
public class FeedbackService {

	@Autowrie
	private FeedbackDao feedbackDao;

	public FeedbackDao getFeedbackDao() {
		return feedbackDao;
	}

	public void setFeedbackDao(FeedbackDao feedbackDao) {
		this.feedbackDao = feedbackDao;
	}
	
	@Post
	@Path("/error/patent")
	public long errorPatent(@JdbcConn(true) Connection con,String cnt,String id,@Nullable String user)throws SQLException{
		Feedback fb = new Feedback();
		fb.setCategory(1);
		fb.setSchema(2);
		fb.setParam(id);
		fb.setState("0");
		fb.setContent(cnt);
		fb.setUserId(user);
		return this.feedbackDao.insert(con, fb);
	}
	
	@Post
	@Path("/error/paper")
	public long errorPaper(@JdbcConn(true) Connection con,String cnt,String id,@Nullable String user)throws SQLException{
		Feedback fb = new Feedback();
		fb.setCategory(1);
		fb.setSchema(1);
		fb.setParam(id);
		fb.setState("0");
		fb.setContent(cnt);
		fb.setUserId(user);
		return this.feedbackDao.insert(con, fb);
	}
	@Post
	@Path("/error/professor")
	public long errorProfessor(@JdbcConn(true) Connection con,String cnt,String id,@Nullable String user)throws SQLException{
		Feedback fb = new Feedback();
		fb.setCategory(1);
		fb.setSchema(3);
		fb.setParam(id);
		fb.setState("0");
		fb.setContent(cnt);
		fb.setUserId(user);
		return this.feedbackDao.insert(con, fb);
	}
	
	@Post
	@Path("/error/org")
	public long errorOrg(@JdbcConn(true) Connection con,String cnt,String id,@Nullable String user)throws SQLException{
		Feedback fb = new Feedback();
		fb.setCategory(1);
		fb.setSchema(4);
		fb.setParam(id);
		fb.setState("0");
		fb.setContent(cnt);
		fb.setUserId(user);
		return this.feedbackDao.insert(con, fb);
	}
	
	@Post
	@Path("/error/resource")
	public long errorResource(@JdbcConn(true) Connection con,String cnt,String id,@Nullable String user)throws SQLException{
		Feedback fb = new Feedback();
		fb.setCategory(1);
		fb.setSchema(5);
		fb.setParam(id);
		fb.setState("0");
		fb.setContent(cnt);
		fb.setUserId(user);
		return this.feedbackDao.insert(con, fb);
	}
	
	@Post
	@Path("/error/article")
	public long errorArticle(@JdbcConn(true) Connection con,String cnt,String id,@Nullable String user)throws SQLException{
		Feedback fb = new Feedback();
		fb.setCategory(1);
		fb.setSchema(6);
		fb.setParam(id);
		fb.setState("0");
		fb.setContent(cnt);
		fb.setUserId(user);
		return this.feedbackDao.insert(con, fb);
	}
	
	@Post
	@Path("/error")
	public long error(@JdbcConn(true) Connection con,String cnt,String id,@Nullable String user,int schema)throws SQLException{
		Feedback fb = new Feedback();
		fb.setCategory(1);
		fb.setSchema(schema);
		fb.setParam(id);
		fb.setState("0");
		fb.setContent(cnt);
		fb.setUserId(user);
		return this.feedbackDao.insert(con, fb);
	}
	
	@Post
	@Path("/error/demand")
	public long errorDemand(@JdbcConn(true) Connection con,String cnt,String id,@Nullable String user)throws SQLException{
		Feedback fb = new Feedback();
		fb.setCategory(1);
		fb.setParam(id);
		fb.setState("0");
		fb.setContent(cnt);
		fb.setUserId(user);
		fb.setSchema(7);
		return this.feedbackDao.insert(con, fb);
	}
	@Post
	@Path("/error/question")
	public long errorQuestion(@JdbcConn(true) Connection con,String cnt,String id,@Nullable String user)throws SQLException{
		Feedback fb = new Feedback();
		fb.setCategory(1);
		fb.setParam(id);
		fb.setState("0");
		fb.setContent(cnt);
		fb.setUserId(user);
		fb.setSchema(8);
		return this.feedbackDao.insert(con, fb);
	}
	@Post
	@Path("/error/answer")
	public long errorAnswer(@JdbcConn(true) Connection con,String cnt,String id,@Nullable String user)throws SQLException{
		Feedback fb = new Feedback();
		fb.setCategory(1);
		fb.setParam(id);
		fb.setState("0");
		fb.setContent(cnt);
		fb.setUserId(user);
		fb.setSchema(9);
		return this.feedbackDao.insert(con, fb);
	}
	@Post
	@Path("/error/ware")
	public long errorWare(@JdbcConn(true) Connection con,String cnt,String id,@Nullable String user)throws SQLException{
		Feedback fb = new Feedback();
		fb.setCategory(1);
		fb.setParam(id);
		fb.setState("0");
		fb.setContent(cnt);
		fb.setUserId(user);
		fb.setSchema(10);
		return this.feedbackDao.insert(con, fb);
	}
}
