package com.ekexiu.portal.service;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.ArrayList;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Bean;

import com.ekexiu.portal.dao.ArtKeyWordDao;
import com.ekexiu.portal.dao.OrgKeyWordDao;
import com.ekexiu.portal.dao.PapKeyWordDao;
import com.ekexiu.portal.dao.PatKeyWordDao;
import com.ekexiu.portal.dao.ProKeyWordDao;
import com.ekexiu.portal.dao.ResKeyWordDao;
import com.ekexiu.portal.po.ArtKeyWord;
import com.ekexiu.portal.po.OrgKeyWord;
import com.ekexiu.portal.po.PapKeyWord;
import com.ekexiu.portal.po.PatKeyWord;
import com.ekexiu.portal.po.ProKeyWord;
import com.ekexiu.portal.po.ResKeyWord;
import com.ekexiu.portal.ware.WreKeyWord;
import com.ekexiu.portal.ware.WreKeyWordDao;

@Bean
public class KeyWordService {

	@Autowrie
	private ProKeyWordDao proKeyWordDao;
	@Autowrie
	private OrgKeyWordDao orgKeyWordDao;
	@Autowrie
	private ResKeyWordDao resKeyWordDao;
	@Autowrie
	private ArtKeyWordDao artKeyWordDao;
	@Autowrie
	private PatKeyWordDao patKeyWordDao;
	@Autowrie
	private PapKeyWordDao papKeyWordDao;
	@Autowrie
	private WreKeyWordDao wreKeyWordDao;
	
	

	public WreKeyWordDao getWreKeyWordDao() {
		return wreKeyWordDao;
	}

	public void setWreKeyWordDao(WreKeyWordDao wreKeyWOrdDao) {
		this.wreKeyWordDao = wreKeyWOrdDao;
	}

	public ProKeyWordDao getProKeyWordDao() {
		return proKeyWordDao;
	}

	public void setProKeyWordDao(ProKeyWordDao proKeyWordDao) {
		this.proKeyWordDao = proKeyWordDao;
	}

	public OrgKeyWordDao getOrgKeyWordDao() {
		return orgKeyWordDao;
	}

	public void setOrgKeyWordDao(OrgKeyWordDao orgKeyWordDao) {
		this.orgKeyWordDao = orgKeyWordDao;
	}

	public ResKeyWordDao getResKeyWordDao() {
		return resKeyWordDao;
	}

	public void setResKeyWordDao(ResKeyWordDao resKeyWordDao) {
		this.resKeyWordDao = resKeyWordDao;
	}

	public ArtKeyWordDao getArtKeyWordDao() {
		return artKeyWordDao;
	}

	public void setArtKeyWordDao(ArtKeyWordDao artKeyWordDao) {
		this.artKeyWordDao = artKeyWordDao;
	}

	public PatKeyWordDao getPatKeyWordDao() {
		return patKeyWordDao;
	}

	public void setPatKeyWordDao(PatKeyWordDao patKeyWordDao) {
		this.patKeyWordDao = patKeyWordDao;
	}

	public PapKeyWordDao getPapKeyWordDao() {
		return papKeyWordDao;
	}

	public void setPapKeyWordDao(PapKeyWordDao papKeyWordDao) {
		this.papKeyWordDao = papKeyWordDao;
	}

	public void refreshWrae(Connection con,String id,String[] kws)throws SQLException{
		wreKeyWordDao.delete(con, id);
		if (kws != null && kws.length > 0) {
			WreKeyWord[] okws = new WreKeyWord[kws.length];
			for (int i = 0; i < kws.length; ++i) {
				WreKeyWord okw = new WreKeyWord();
				okw.setId(id);
				okw.setKw(kws[i]);
				okws[i] = okw;
			}
			wreKeyWordDao.insert(con, okws);
		}
	}
	public void deleteWare(Connection con,String id)throws SQLException{
		wreKeyWordDao.delete(con, id);
	}
	public void refreshProfessor(Connection con, String id, String[] kws) throws SQLException {
		proKeyWordDao.delete(con, id);
		if (kws != null && kws.length > 0) {
			ProKeyWord[] okws = new ProKeyWord[kws.length];
			for (int i = 0; i < kws.length; ++i) {
				ProKeyWord okw = new ProKeyWord();
				okw.setId(id);
				okw.setKw(kws[i]);
				okws[i] = okw;
			}
			proKeyWordDao.insert(con, okws);
		}
	}

	public void refreshOrg(Connection con, String id, String[] kws) throws SQLException {
		orgKeyWordDao.delete(con, id);
		if (kws != null && kws.length > 0) {
			OrgKeyWord[] okws = new OrgKeyWord[kws.length];
			for (int i = 0; i < kws.length; ++i) {
				OrgKeyWord okw = new OrgKeyWord();
				okw.setId(id);
				okw.setKw(kws[i]);
				okws[i] = okw;
			}
			orgKeyWordDao.insert(con, okws);
		}
	}

	public void refreshArticle(Connection con, String id, String[] kws) throws SQLException {
		artKeyWordDao.delete(con, id);
		if (kws != null && kws.length > 0) {
			ArtKeyWord[] okws = new ArtKeyWord[kws.length];
			for (int i = 0; i < kws.length; ++i) {
				ArtKeyWord okw = new ArtKeyWord();
				okw.setId(id);
				okw.setKw(kws[i]);
				okws[i] = okw;
			}
			artKeyWordDao.insert(con, okws);
		}
	}

	public void refreshResource(Connection con, String id, String[] kws) throws SQLException {
		resKeyWordDao.delete(con, id);
		if (kws != null && kws.length > 0) {
			ResKeyWord[] okws = new ResKeyWord[kws.length];
			for (int i = 0; i < kws.length; ++i) {
				ResKeyWord okw = new ResKeyWord();
				okw.setId(id);
				okw.setKw(kws[i]);
				okws[i] = okw;
			}
			resKeyWordDao.insert(con, okws);
		}
	}

	public void refreshPaper(Connection con, String id, String[] kws) throws SQLException {
		papKeyWordDao.delete(con, id);
		if (kws != null && kws.length > 0) {
			PapKeyWord[] okws = new PapKeyWord[kws.length];
			for (int i = 0; i < kws.length; ++i) {
				PapKeyWord okw = new PapKeyWord();
				okw.setId(id);
				okw.setKw(kws[i]);
				okws[i] = okw;
			}
			papKeyWordDao.insert(con, okws);
		}
	}

	public void refreshPatent(Connection con, String id, String[] kws) throws SQLException {
		patKeyWordDao.delete(con, id);
		if (kws != null && kws.length > 0) {
			PatKeyWord[] okws = new PatKeyWord[kws.length];
			for (int i = 0; i < kws.length; ++i) {
				PatKeyWord okw = new PatKeyWord();
				okw.setId(id);
				okw.setKw(kws[i]);
				okws[i] = okw;
			}
			patKeyWordDao.insert(con, okws);
		}
	}

	public static String[] splitKeyWord(String kws) {
		if (kws == null || kws.trim().length() == 0)
			return null;
		kws = kws.trim();
		ArrayList<String> result = new ArrayList<String>();
		char[] cs = kws.toCharArray();
		int mi = cs.length;
		if (mi > 0) {
			int begin = 0;
			for (int i = 0; i < mi; ++i) {
				char c = cs[i];
				if (c == ',') {
					if (i != begin) {
						String kw = new String(cs, begin, i - begin);
						if (!result.contains(kw)) {
							result.add(new String(cs, begin, i - begin));
						}
					}
					begin = i + 1;
				}
			}
			if (begin != mi)
				result.add(new String(cs, begin, mi - begin));
		}
		return result.isEmpty() ? null : result.toArray(new String[result.size()]);
	}

}
