package com.ekexiu.portal.service;

import java.sql.Connection;
import java.sql.SQLException;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.PageQueryResult;

import com.ekexiu.portal.dao.ProfessorDao;
import com.ekexiu.portal.dao.ResourceTmpDao;
import com.ekexiu.portal.po.ResourceTmp;
import com.ekexiu.portal.pojo.EditProfessor;

@Path("/resTmp")
public class ResourceTmpService {
	@Autowrie
	private ResourceTmpDao resourceTmpDao;
	@Autowrie
	private ProfessorDao professorDao;

	public ResourceTmpDao getResourceTmpDao() {
		return resourceTmpDao;
	}

	public void setResourceTmpDao(ResourceTmpDao resourceTmpDao) {
		this.resourceTmpDao = resourceTmpDao;
	}
	
	public ProfessorDao getProfessorDao() {
		return professorDao;
	}

	public void setProfessorDao(ProfessorDao professorDao) {
		this.professorDao = professorDao;
	}

	@Get
	@Path("/pq")
	public PageQueryResult<ResourceTmp> query(@JdbcConn Connection con,String professorId,@Nullable String key,@DefaultValue("10") int pageSize,@DefaultValue("1") int pageNo)throws SQLException{
		EditProfessor professor = this.professorDao.queryBaseInfo(con, professorId);
		String orgName = null;
		if(professor != null){
			orgName = professor.getOrgName();
		}
		if(orgName == null || "".equals(orgName)){
			return null;
		}
		if(key != null){
			key = "%" + key + "%";
		}
		return this.resourceTmpDao.query(con, orgName, key, pageSize, pageNo);
	}
}
