package com.ekexiu.portal.util;

import org.jfw.util.log.Logger;

public class Log4jLogger implements Logger {
	
	private final org.apache.log4j.Logger log;
	
	 public Log4jLogger(org.apache.log4j.Logger log) {
		 this.log = log;
	 }

	@Override
	public boolean isEnableTrace() {
		return log.isTraceEnabled();
	}

	@Override
	public void trace(String message) {
		log.trace(message);
	}

	@Override
	public void trace(String message, Throwable t) {
		log.trace(message, t);
	}

	@Override
	public boolean isEnableDebug() {
		return log.isDebugEnabled();
	}

	@Override
	public void debug(String message) {
		log.debug(message);		
	}

	@Override
	public void debug(String message, Throwable t) {
		log.debug(message, t);
	}

	@Override
	public boolean isEnableInfo() {
		return log.isInfoEnabled();
	}

	@Override
	public void info(String message) {
		log.info(message);
	}

	@Override
	public void info(String message, Throwable t) {
		log.info(message, t);
	}

	@Override
	public boolean isEnableWarn() {
		return true;
	}

	@Override
	public void warn(String message) {
		log.warn(message);
	}

	@Override
	public void warn(String message, Throwable t) {
		log.warn(message, t);
	}

	@Override
	public void error(String message) {
		log.error(message);
	}

	@Override
	public void error(String message, Throwable t) {
		log.error(message, t);
	}

	@Override
	public void fatal(String message) {
		log.fatal(message);
	}

	@Override
	public void fatal(String message, Throwable t) {
		log.fatal(message, t);
	}

}
